//---------------------------------------------------------------------------
//
// Module: CHMcompositeGrammarDll
//
// Description:
//
//---------------------------------------------------------------------------

#ifndef __CHM_COMPOSITE_GRAMMAR_DLL__
#define __CHM_COMPOSITE_GRAMMAR_DLL__
#include <CHM/CHMminimumInclude.h>

CHM_DLL_FUNC(CHMcompositeDump)
(
   CHMcompositeHandle Handle,
   CHMchar**          ppDumpString
);

CHM_DLL_FUNC(CHMcompositeGetName)
(
   CHMcompositeHandle Handle,
   const CHMchar**          ppName
);

CHM_DLL_FUNC(CHMcompositeSetName)
(
   CHMcompositeHandle Handle,
   CHMchar*         pName
);

CHM_DLL_FUNC(CHMcompositeGetDescription)
(
   CHMcompositeHandle Handle,
   const CHMchar**          ppDescription
);

CHM_DLL_FUNC(CHMcompositeSetDescription)
(
   CHMcompositeHandle Handle,
   CHMchar*           pDescription
);

CHM_DLL_FUNC(CHMcompositeGetFieldDateTimeGrammar)
(
   CHMcompositeHandle        Handle,
   size_t                    FieldIndex,
   CHMdateTimeGrammarHandle* pDateTimeGrammarHandle
);

CHM_DLL_FUNC(CHMcompositeSetFieldDateTimeGrammar)
(
   CHMcompositeHandle        Handle,
   size_t                    FieldIndex,
   CHMdateTimeGrammarHandle  DateTimeGrammarHandle
);

CHM_DLL_FUNC(CHMcompositeCountOfField)
(
   CHMcompositeHandle Handle,
   size_t*            pCountOfField
);

CHM_DLL_FUNC(CHMcompositeGetFieldName)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   const CHMchar**          ppFieldName
);

CHM_DLL_FUNC(CHMcompositeSetFieldName)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   CHMchar*           pFieldName
);

CHM_DLL_FUNC(CHMcompositeGetFieldCompositeType)
(
   CHMcompositeHandle  Handle,
   size_t              FieldIndex,
   CHMcompositeHandle* pFieldCompositeHandle
);

CHM_DLL_FUNC(CHMcompositeSetFieldCompositeType)
(
   CHMcompositeHandle  Handle,
   size_t              FieldIndex,
   CHMcompositeHandle  FieldCompositeHandle
);

CHM_DLL_FUNC(CHMcompositeGetFieldDataType)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t*            pDataType
);

CHM_DLL_FUNC(CHMcompositeSetFieldDataType)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t             DataType
);

CHM_DLL_FUNC(CHMcompositeRemoveField)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex
);

CHM_DLL_FUNC(CHMcompositeGetFieldMaxLength)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t*            pMaxLength
);

CHM_DLL_FUNC(CHMcompositeSetFieldMaxLength)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t             MaxLength
);

CHM_DLL_FUNC(CHMcompositeGetIsFieldLengthRestricted)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t*            pIsFieldLengthRestricted
);

CHM_DLL_FUNC(CHMcompositeSetIsFieldLengthRestricted)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t             IsFieldLengthRestricted
);

CHM_DLL_FUNC(CHMcompositeGetIsFieldRequired)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t*            pIsFieldRequired
);

CHM_DLL_FUNC(CHMcompositeSetIsFieldRequired)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex,
   size_t             IsFieldRequired
);

CHM_DLL_FUNC(CHMcompositeAddFieldAt)
(
   CHMcompositeHandle Handle,
   size_t             FieldIndex
);

CHM_DLL_FUNC(CHMcompositeGetIsNode)
(
   CHMcompositeHandle Handle,
   size_t*            pIsNode
);

CHM_DLL_FUNC(CHMcompositeAddField)
(
   CHMcompositeHandle Handle
);

#endif // end of defensive include
