//---------------------------------------------------------------------------
//
// Module: CHMdateTimeGrammarDll
//
// Description:
//
//---------------------------------------------------------------------------

#ifndef __CHM_DATE_TIME_GRAMMAR_DLL__
#define __CHM_DATE_TIME_GRAMMAR_DLL__
#include <CHM/CHMminimumInclude.h>

CHM_DLL_FUNC(CHMdateTimeGrammarDump)
(
   CHMdateTimeGrammarHandle Handle,
   CHMchar**                ppDumpString
);

CHM_DLL_FUNC(CHMdateTimeGrammarGetName)
(
   CHMdateTimeGrammarHandle Handle,
   const CHMchar**                ppName
);

CHM_DLL_FUNC(CHMdateTimeGrammarSetName)
(
   CHMdateTimeGrammarHandle Handle,
   const CHMchar*                 pName
);

CHM_DLL_FUNC(CHMdateTimeGrammarGetDescription)
(
   CHMdateTimeGrammarHandle Handle,
   const CHMchar**                ppDescription
);

CHM_DLL_FUNC(CHMdateTimeGrammarSetDescription)
(
   CHMdateTimeGrammarHandle Handle,
   const CHMchar*                 pDescription
);

CHM_DLL_FUNC(CHMdateTimeGrammarAddMaskItem)
(
   CHMdateTimeGrammarHandle Handle
);

CHM_DLL_FUNC(CHMdateTimeGrammarAddMaskItemAt)
(
   CHMdateTimeGrammarHandle Handle,
   size_t                   Index
);

CHM_DLL_FUNC(CHMdateTimeGrammarRemoveMaskItem)
(
   CHMdateTimeGrammarHandle Handle,
   size_t                   Index
);

CHM_DLL_FUNC(CHMdateTimeGrammarGetCountOfMaskItem)
(
   CHMdateTimeGrammarHandle Handle,
   size_t*                  pCountOfMaskItem
);

CHM_DLL_FUNC(CHMdateTimeGrammarGetMaskItem)
(
   CHMdateTimeGrammarHandle Handle,
   size_t                   ItemIndex,
   size_t*                  pMaskItem
);

CHM_DLL_FUNC(CHMdateTimeGrammarPutMaskItem)
(
   CHMdateTimeGrammarHandle Handle,
   size_t                   ItemIndex,
   size_t                   MaskItem
);

CHM_DLL_FUNC(CHMdateTimeGrammarAllFieldsRequired)
(
   CHMdateTimeGrammarHandle Handle,
   size_t*                  pAllFieldsRequired
);

CHM_DLL_FUNC(CHMdateTimeGrammarGetListOfDependencies)
(
   CHMdateTimeGrammarHandle Handle,
   const CHMchar**          ppList                  
);

#endif // end of defensive include
