#ifndef __CHM_EXCEPTION_DLL_H__
#define __CHM_EXCEPTION_DLL_H__
/**
 * Copyright (C) 1997-2006 iNTERFACEWARE Inc. All Rights Reserved.
 *
 * Module: CHMexception
 *
 * This file is maintained by hand.
 *
**/

#include <CHM/CHMminimumInclude.h>

#ifndef __CHM_EXCEPTION_HANDLE_H__
#define __CHM_EXCEPTION_HANDLE_H__
typedef void* CHMexceptionHandle;
#endif


CHM_DLL_FUNC(CHMexceptionCreate)
(
   CHMexceptionHandle* pResult
);

CHM_DLL_FUNC(CHMexceptionAddRef)
(
   CHMexceptionHandle Handle
);

CHM_DLL_FUNC(CHMexceptionRelease)
(
   CHMexceptionHandle Handle
);

CHM_DLL_FUNC(CHMexceptionGetDescription)
(
   CHMexceptionHandle Handle,
   const char** pResult
);

CHM_DLL_FUNC(CHMexceptionGetCode)
(
   CHMexceptionHandle Handle,
   CHMint32* pResult
);

CHM_DLL_FUNC(CHMexceptionGetParameter)
(
   CHMexceptionHandle Handle,
   const char* Key,
   const char** pResult
);

CHM_DLL_FUNC(CHMexceptionGetCountOfParameter)
(
   CHMexceptionHandle Handle,
   CHMint32* pResult
);

CHM_DLL_FUNC(CHMexceptionGetKey)
(
   CHMexceptionHandle Handle,
   CHMint32 KeyIndex,
   const char** pResult
);
#endif // end of defensive include
