//---------------------------------------------------------------------------
// Module: CHMminimumInclude.h 
//
// Description:
//
// Minimal include file used by exported DLL interface classes
//
//---------------------------------------------------------------------------

#ifndef __CHM_MINIMUM_INCLUDE_H__
#define __CHM_MINIMUM_INCLUDE_H__

#include <CHM/CHMglobalDefines.h>
#include <CHM/CHMdataType.h>
#include <CHM/CHMminCInclude.h>
#include <stdlib.h>
#include <CHM/CHMinstanceHeap.h>

#ifndef __NPOS_DEFINED__
   const size_t npos = 0xFFFFFFFF;
#define __NPOS_DEFINED__
#endif 

#include <CHM/CHMunicode.h>

#include <stddef.h>

#ifndef CHM_STD_CALL
#ifdef WIN32
#   define CHM_STD_CALL __stdcall
#else
#   define CHM_STD_CALL 
#endif
#endif

#endif // end of defensive include
