//---------------------------------------------------------------------------
//
// Module: CHMsegmentDll
//
// Description:
//
//---------------------------------------------------------------------------

#ifndef __CHM_SEGMENT_DLL__
#define __CHM_SEGMENT_DLL__
#include <CHM/CHMminimumInclude.h>

CHM_DLL_FUNC(CHMsegmentDump)
(
   CHMsegmentHandle Handle,
   CHMchar**        ppDumpString
);

CHM_DLL_FUNC(CHMsegmentGetName)
(
   CHMsegmentHandle Handle,
   const CHMchar**        ppName
);

CHM_DLL_FUNC(CHMsegmentSetName)
(
   CHMsegmentHandle Handle,
   const CHMchar*         pName
);

CHM_DLL_FUNC(CHMsegmentGetDescription)
(
   CHMsegmentHandle Handle,
   const CHMchar**        ppDescription
);

CHM_DLL_FUNC(CHMsegmentSetDescription)
(
   CHMsegmentHandle Handle,
   const CHMchar*         pDescription
);

CHM_DLL_FUNC(CHMsegmentGetFieldMaxRepeats)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   size_t*          pMaxRepeats
);

CHM_DLL_FUNC(CHMsegmentSetFieldMaxRepeats)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   size_t           MaxRepeats
);

CHM_DLL_FUNC(CHMsegmentGetFieldIsRequired)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   size_t*          pIsRequired
);

CHM_DLL_FUNC(CHMsegmentSetFieldIsRequired)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   size_t           IsRequired
);

CHM_DLL_FUNC(CHMsegmentGetFieldDefault)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   const CHMchar**        ppFieldDefault
);

CHM_DLL_FUNC(CHMsegmentSetFieldDefault)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   const CHMchar*         pFieldDefault
);

CHM_DLL_FUNC(CHMsegmentGetFieldName)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   const CHMchar**        ppFieldName
);

CHM_DLL_FUNC(CHMsegmentSetFieldName)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex,
   const CHMchar*         pFieldName
);

CHM_DLL_FUNC(CHMsegmentGetFieldType)
(
   CHMsegmentHandle    Handle,
   size_t              FieldIndex,
   CHMcompositeHandle* pFieldHandle
);

CHM_DLL_FUNC(CHMsegmentSetFieldType)
(
   CHMsegmentHandle   Handle,
   size_t             FieldIndex,
   CHMcompositeHandle FieldHandle
);

CHM_DLL_FUNC(CHMsegmentRemoveField)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex
);

CHM_DLL_FUNC(CHMsegmentAddField)
(
   CHMsegmentHandle Handle
);

CHM_DLL_FUNC(CHMsegmentAddFieldAt)
(
   CHMsegmentHandle Handle,
   size_t           FieldIndex
);

CHM_DLL_FUNC(CHMsegmentCountOfField)
(
   CHMsegmentHandle Handle,
   size_t*          pCountOfField
);

#endif // end of defensive include
