#ifndef __CHM_CONNECTION_INFO_H__
#define __CHM_CONNECTION_INFO_H__

// This class is really just a simple struct to pass information
// about a message - usually about the transport mechanism - such
// as the socket to use to return the message.  The intention is
// for this class to be customised by developers to meet the
// requirements for their particular transport.

class CHMsocket;

class CHMconnectionInfo
{
public:
   CHMconnectionInfo() {}
   ~CHMconnectionInfo() {}

   // the socket to return the ACK/NACK to...
   CHMsocket* pSocket;  
private:
   // not allowed
   CHMconnectionInfo(const CHMconnectionInfo& Orig);
   CHMconnectionInfo& operator=(const CHMconnectionInfo& Orig);
};

#endif // end of defensive include
