#ifndef __CHM_COUT_OUTPUT_LOG__
#define __CHM_COUT_OUTPUT_LOG__
//------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMcoutOutputLog
//
// Description:
//   Simple implementation of CHMoutputLog interface.
//
// Author: Greg Norman
// Revision: $Revision: 1.8 $
//
// Last Edit Date: $Date: 2007-02-12 21:35:42 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMcoutOutputLog.h,v $
//---------------------------------------------------------------------------
#include <CHM/CHMoutputLog.h>

/** Logs output to \c stdout. 
 * Simple implementation of CHMoutputLog interface.
 **/
class CHMcoutOutputLog : public CHMoutputLog
{
public:
   /** Constructor. */
   CHMcoutOutputLog() {}
   /** Destructor. */
   virtual ~CHMcoutOutputLog() {}
   
   /** Output \c pLine to \c stdout. */
   virtual void OutputLine(const CHMchar* pLine);

private:
   // not allowed
   CHMcoutOutputLog(const CHMcoutOutputLog& Orig);
   CHMcoutOutputLog& operator=(const CHMcoutOutputLog& Orig);
};
#endif // end of defensive include

