#ifndef __CHM_MESSAGE_H_
#define __CHM_MESSAGE_H_
//---------------------------------------------------------------------------
// Module: CHMmessage
//
// Description:
//
// The class forms the interface to Chameleon Message objects 
// It only exposes the methods required by the client code.  In this
// way it will make future relinking and maintenance easy.
// 
//---------------------------------------------------------------------------

#include <CHM/CHMcallbackFunction.h>

CHM_DLL_FUNC(CHMmessageGetCountOfIdentifier)
(
   CHMmessageHandle Handle,
   size_t*          pCountOfIdentifier
);

CHM_DLL_FUNC(CHMmessageGetIdentValue)
(
   CHMmessageHandle   Handle,
   size_t             IdentIndex,
   const CHMchar**    ppValue
);

#endif // end of defensive include
