#ifndef __CHM_MESSAGE_DEFINITION_CLASS_H__
#define __CHM_MESSAGE_DEFINITION_CLASS_H__

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMdataType.h>
class CHMmessageDefinitionPrivate;

class CHMmessageDefinition
{
public:
   CHMmessageDefinition();
   explicit CHMmessageDefinition(CHMmessageHandle Handle);
   virtual ~CHMmessageDefinition();

   const char* GetMessageName() const;
   const char* GetMessageDescription() const;
   CHMmessageHandle GetMessageDefHandle() const;
   CHMtableGrammarHandle GetTableGrammar() const;
 
private:
   CHMmessageDefinitionPrivate* pMember;
   CHMmessageDefinition(const CHMmessageDefinition& Orig);             // not allowed
   CHMmessageDefinition& operator=(const CHMmessageDefinition& Orig);  // not allowed
};

//IOostream& operator<<(IOostream& Stream, const CHMmessageDefinition& TableDef);

#endif // __CHM_MESSAGE_DEFINITION_CLASS_H__
