//---------------------------------------------------------------------------
// Module: CHMmessageDll
//
// Description:
//
// The class forms the interface to the Chameleon Message object
// It only exposes the methods required by the client code.  In this
// way it will make future relinking and maintenance easy.
// 
//---------------------------------------------------------------------------

#ifndef __CHM_MESSAGE_DLL_H__
#define __CHM_MESSAGE_DLL_H__
#include <CHM/CHMminimumInclude.h>

CHM_DLL_FUNC(CHMmessageGetDescription)
(
   CHMmessageHandle Handle,
   const CHMchar**  ppDescription
);

CHM_DLL_FUNC(CHMmessageSetName)
(
   CHMmessageHandle Handle,
   const CHMchar*   pName
);

CHM_DLL_FUNC(CHMmessageGetName)
(
   CHMmessageHandle Handle,
   const CHMchar**  ppName
);

#endif // end of defensive include
