#ifndef __IGC_EXCEPTION_DLL_H__
#define __IGC_EXCEPTION_DLL_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: IGCexceptionDll
//
// Description:
//
// DLL Interface.
//
// Revision: $Revision: 1.6 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCexceptionDll.h,v $
// Author: Code Generator
// Last Edit Date: $Date: 2009-05-22 02:26:21 $
//---------------------------------------------------------------------------
#include <IGC/IGCminimumInclude.h>

#ifndef __IGC_EXCEPTION_HANDLE_H__
#define __IGC_EXCEPTION_HANDLE_H__
typedef void* IGCexceptionStubHandle;
typedef void* IGCexceptionHandle;
#endif

IGC_DLL_FUNC(IGCexceptionCreate)
(
   IGCexceptionStubHandle StubHandle,
   IGCexceptionHandle* Handle
);

IGC_DLL_FUNC(IGCexceptionCreateWithDescription)
(
   IGCexceptionStubHandle StubHandle,
   IGCexceptionHandle* Handle,
   const char* Description
);

IGC_DLL_FUNC(IGCexceptionCopy)
(
   IGCexceptionStubHandle StubHandle,
   IGCexceptionHandle RhsHandle,
   IGCexceptionHandle* Handle
);

IGC_DLL_FUNC(IGCexceptionAddRef)
(
   IGCexceptionHandle Handle
);

IGC_DLL_FUNC(IGCexceptionRelease)
(
   IGCexceptionHandle Handle
);

IGC_DLL_FUNC(IGCexceptionDestroy)
(
   IGCexceptionHandle Handle
);

IGC_DLL_FUNC(IGCexceptionDestroy)
(
   IGCexceptionHandle Handle
);

IGC_DLL_FUNC(IGCexceptionGetStubHandle)
(
   IGCexceptionHandle Handle,
   IGCexceptionStubHandle* StubHandle
);


IGC_DLL_FUNC(IGCexceptionGetDescription)
(
   IGCexceptionHandle Handle,
   const char** Description
);


IGC_DLL_FUNC(IGCexceptionSetDescription)
(
   IGCexceptionHandle Handle,
   const char* Description
);

#endif // end of defensive include

